extends RigidBody2D

var knockBackHeightMax = 500
var knockBackHeightMin = 300
var knockBackSideMax = 900
var knockBackSideMin = 350

var beingKnockedBack = false

func _on_Ball_body_entered(body):
	if body.is_in_group("BALL"):
		sleeping = true
	
	pass

func _physics_process(delta):
	if contacts_reported > 1:
		sleeping = true
		#beingKnockedBack = false
	
func changeToStatic():
	mode = 1
	
func changeToRigid():
	sleeping = false
	mode = 0

func _on_Ball_sleeping_state_changed():
	if sleeping:
		
		call_deferred("changeToStatic")
	else:
		call_deferred("changeToRigid")

func explode():
	queue_free()
	
var rocketPosition = Vector2()
	
func knockBackReal():
	var knockBack = Vector2(0, -(randi()%knockBackHeightMax + knockBackHeightMin))
	if position.x < rocketPosition.x:	#if ball is to left of rocket
		knockBack.x = (-(randi()%knockBackSideMax + knockBackSideMin)-(rocketPosition.x-position.x))
		#knockBack.x = -500
	else:	#if ball is to right of rocket
		knockBack.x = ((randi()%knockBackSideMax + knockBackSideMin)-(position.x-rocketPosition.x))
		#knockBack.x = 500
	
	apply_impulse(rocketPosition - position, knockBack)
	
func knockedBack(rp):
	beingKnockedBack = true
	$Timer.start()
	rocketPosition = rp
	call_deferred("changeToRigid")
	call_deferred("knockBackReal")




func _on_Timer_timeout():
	beingKnockedBack = false
